diff --git a/src/mongo/db/catalog/collection_impl.cpp b/src/mongo/db/catalog/collection_impl.cpp
index 4389b6b764..f019cd5879 100644
--- a/src/mongo/db/catalog/collection_impl.cpp
+++ b/src/mongo/db/catalog/collection_impl.cpp
@@ -240,16 +240,25 @@ Status CollectionImpl::checkValidation(OperationContext* opCtx, const BSONObj& d
     if (documentValidationDisabled(opCtx))
         return Status::OK();
 
-    if (_validator->matchesBSON(document))
+    std::deque<std::string> explain;
+    if (_validator->matchesBSON(document, nullptr, &explain))
         return Status::OK();
 
+    StringBuilder builder;
+    for (auto&& str : explain) {
+        builder << std::move(str);
+    }
+    const auto reason = builder.str();
+
     if (_validationAction == ValidationAction::WARN) {
         warning() << "Document would fail validation"
-                  << " collection: " << ns() << " doc: " << redact(document);
+                  << " collection: " << ns() << " doc: " << redact(document)
+                  << " reason: " << reason;
         return Status::OK();
     }
 
-    return {ErrorCodes::DocumentValidationFailure, "Document failed validation"};
+    return {ErrorCodes::DocumentValidationFailure,
+            str::stream() << "Document failed validation: " << reason};
 }
 
 StatusWithMatchExpression CollectionImpl::parseValidator(
diff --git a/src/mongo/db/catalog/collection_impl.h b/src/mongo/db/catalog/collection_impl.h
index 9c146f8b55..663f028b4b 100644
--- a/src/mongo/db/catalog/collection_impl.h
+++ b/src/mongo/db/catalog/collection_impl.h
@@ -118,7 +118,7 @@ public:
                  Snapshotted<BSONObj>* out) const final;
 
     std::unique_ptr<SeekableRecordCursor> getCursor(OperationContext* opCtx,
-                                                    bool forward = true) const final;
+                                                    bool forward) const final;
 
     /**
      * Deletes the document with the given RecordId from the collection.
diff --git a/src/mongo/db/exec/geo_near.cpp b/src/mongo/db/exec/geo_near.cpp
index 80923c4f55..248e0f970e 100644
--- a/src/mongo/db/exec/geo_near.cpp
+++ b/src/mongo/db/exec/geo_near.cpp
@@ -508,7 +508,9 @@ public:
         out->append("TwoDPtInAnnulusExpression", true);
     }
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* = nullptr,
+                              std::deque<std::string>* = nullptr) const final {
         if (!e.isABSONObj())
             return false;
 
diff --git a/src/mongo/db/exec/projection_exec.cpp b/src/mongo/db/exec/projection_exec.cpp
index ae17257c9e..acdeac4485 100644
--- a/src/mongo/db/exec/projection_exec.cpp
+++ b/src/mongo/db/exec/projection_exec.cpp
@@ -266,11 +266,11 @@ Status ProjectionExec::transform(WorkingSetMember* member) const {
 
     BSONObjBuilder bob;
     if (member->hasObj()) {
-        MatchDetails matchDetails;
+        ArrayPositionalMatch matchDetails;
 
-        // If it's a positional projection we need a MatchDetails.
+        // If it's a positional projection we need a ArrayPositionalMatch.
         if (transformRequiresDetails()) {
-            matchDetails.requestElemMatchKey();
+            matchDetails.requestArrayPosition();
             verify(NULL != _queryExpression);
             verify(_queryExpression->matchesBSON(member->obj.value(), &matchDetails));
         }
@@ -378,7 +378,7 @@ Status ProjectionExec::transform(WorkingSetMember* member) const {
 
 Status ProjectionExec::transform(const BSONObj& in,
                                  BSONObjBuilder* bob,
-                                 const MatchDetails* details) const {
+                                 const ArrayPositionalMatch* details) const {
     const ArrayOpType& arrayOpType = _arrayOpType;
 
     BSONObjIterator it(in);
@@ -408,8 +408,8 @@ Status ProjectionExec::transform(const BSONObj& in,
             return Status(ErrorCodes::BadValue, "Matchers are only supported for $elemMatch");
         }
 
-        MatchDetails arrayDetails;
-        arrayDetails.requestElemMatchKey();
+        ArrayPositionalMatch arrayDetails;
+        arrayDetails.requestArrayPosition();
 
         if (matcher->second->matchesBSON(in, &arrayDetails)) {
             FieldMap::const_iterator fieldIt = _fields.find(elt.fieldName());
@@ -426,13 +426,14 @@ Status ProjectionExec::transform(const BSONObj& in,
                               "$elemMatch called on document element with eoo");
             }
 
-            if (in.getField(elt.fieldName()).Obj().getField(arrayDetails.elemMatchKey()).eoo()) {
+            invariant(arrayDetails.arrayPosition());
+            const auto& pos = *arrayDetails.arrayPosition();
+            if (in.getField(elt.fieldName()).Obj().getField(pos).eoo()) {
                 return Status(ErrorCodes::InternalError,
                               "$elemMatch called on array element with eoo");
             }
 
-            arrBuilder.append(
-                in.getField(elt.fieldName()).Obj().getField(arrayDetails.elemMatchKey()));
+            arrBuilder.append(in.getField(elt.fieldName()).Obj().getField(pos));
             subBob.appendArray(matcher->first, arrBuilder.arr());
             Status status = append(bob, subBob.done().firstElement(), details, arrayOpType);
             if (!status.isOK()) {
@@ -492,7 +493,7 @@ void ProjectionExec::appendArray(BSONObjBuilder* bob, const BSONObj& array, bool
 
 Status ProjectionExec::append(BSONObjBuilder* bob,
                               const BSONElement& elt,
-                              const MatchDetails* details,
+                              const ArrayPositionalMatch* details,
                               const ArrayOpType arrayOpType) const {
     // Skip if the field name matches a computed $meta field.
     // $meta projection fields can exist at the top level of
@@ -528,7 +529,7 @@ Status ProjectionExec::append(BSONObjBuilder* bob,
         BSONObjBuilder matchedBuilder;
         if (details && arrayOpType == ARRAY_OP_POSITIONAL) {
             // $ positional operator specified
-            if (!details->hasElemMatchKey()) {
+            if (!details->arrayPosition()) {
                 mongoutils::str::stream error;
                 error << "positional operator (" << elt.fieldName()
                       << ".$) requires corresponding field"
@@ -536,12 +537,13 @@ Status ProjectionExec::append(BSONObjBuilder* bob,
                 return Status(ErrorCodes::BadValue, error);
             }
 
-            if (elt.embeddedObject()[details->elemMatchKey()].eoo()) {
+            const auto& pos = *details->arrayPosition();
+            if (elt.embeddedObject()[pos].eoo()) {
                 return Status(ErrorCodes::BadValue, "positional operator element mismatch");
             }
 
             // append as the first and only element in the projected array
-            matchedBuilder.appendAs(elt.embeddedObject()[details->elemMatchKey()], "0");
+            matchedBuilder.appendAs(elt.embeddedObject()[pos], "0");
         } else {
             // append exact array; no subarray matcher specified
             subfm.appendArray(&matchedBuilder, elt.embeddedObject());
diff --git a/src/mongo/db/exec/projection_exec.h b/src/mongo/db/exec/projection_exec.h
index 829cdf0d43..b3f2577de2 100644
--- a/src/mongo/db/exec/projection_exec.h
+++ b/src/mongo/db/exec/projection_exec.h
@@ -110,7 +110,7 @@ private:
      */
     Status transform(const BSONObj& in,
                      BSONObjBuilder* bob,
-                     const MatchDetails* details = NULL) const;
+                     const ArrayPositionalMatch* details = NULL) const;
 
     /**
      * See transform(...) above.
@@ -125,7 +125,7 @@ private:
      */
     Status append(BSONObjBuilder* bob,
                   const BSONElement& elt,
-                  const MatchDetails* details = NULL,
+                  const ArrayPositionalMatch* details = NULL,
                   const ArrayOpType arrayOpType = ARRAY_OP_NORMAL) const;
 
     /**
@@ -166,7 +166,7 @@ private:
 
     ArrayOpType _arrayOpType;
 
-    // The full query expression.  Used when we need MatchDetails.
+    // The full query expression.  Used when we need ArrayPositionalMatch.
     const MatchExpression* _queryExpression;
 
     // Projections that aren't sourced from the document or index keys.
diff --git a/src/mongo/db/exec/update.cpp b/src/mongo/db/exec/update.cpp
index cac39a2972..ab51af6b0c 100644
--- a/src/mongo/db/exec/update.cpp
+++ b/src/mongo/db/exec/update.cpp
@@ -231,15 +231,16 @@ BSONObj UpdateStage::transformAndUpdate(const Snapshotted<BSONObj>& oldObj, Reco
             StringData(), &_doc, validateForStorage, immutablePaths, &logObj, &docWasModified);
     } else {
         // If there was a matched field, obtain it.
-        MatchDetails matchDetails;
-        matchDetails.requestElemMatchKey();
+        ArrayPositionalMatch matchDetails;
+        matchDetails.requestArrayPosition();
 
         dassert(cq);
         verify(cq->root()->matchesBSON(oldObj.value(), &matchDetails));
 
         string matchedField;
-        if (matchDetails.hasElemMatchKey())
-            matchedField = matchDetails.elemMatchKey();
+        if (matchDetails.arrayPosition()) {
+            matchedField = *matchDetails.arrayPosition();
+        }
 
         status = driver->update(
             matchedField, &_doc, validateForStorage, immutablePaths, &logObj, &docWasModified);
diff --git a/src/mongo/db/matcher/SConscript b/src/mongo/db/matcher/SConscript
index 4ed8aa31be..ee8aa3232a 100644
--- a/src/mongo/db/matcher/SConscript
+++ b/src/mongo/db/matcher/SConscript
@@ -29,6 +29,7 @@ env.CppUnitTest(
 env.Library(
     target='expressions',
     source=[
+        'array_positional_match.cpp',
         'expression.cpp',
         'expression_algo.cpp',
         'expression_array.cpp',
@@ -46,7 +47,6 @@ env.Library(
         'expression_with_placeholder.cpp',
         'extensions_callback.cpp',
         'extensions_callback_noop.cpp',
-        'match_details.cpp',
         'matchable.cpp',
         'matcher.cpp',
         'matcher_type_set.cpp',
diff --git a/src/mongo/db/matcher/array_positional_match.cpp b/src/mongo/db/matcher/array_positional_match.cpp
new file mode 100644
index 0000000000..5e6c20d5a3
--- /dev/null
+++ b/src/mongo/db/matcher/array_positional_match.cpp
@@ -0,0 +1,49 @@
+/**
+ * Copyright (C) 2018 MongoDB Inc.
+ *
+ * This program is free software: you can redistribute it and/or  modify
+ * it under the terms of the GNU Affero General Public License, version 3,
+ * as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Affero General Public License for more details.
+ *
+ * You should have received a copy of the GNU Affero General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * As a special exception, the copyright holders give permission to link the
+ * code of portions of this program with the OpenSSL library under certain
+ * conditions as described in each individual source file and distribute
+ * linked combinations including the program with the OpenSSL library. You
+ * must comply with the GNU Affero General Public License in all respects
+ * for all of the code used other than as permitted herein. If you modify
+ * file(s) with this exception, you may extend this exception to your
+ * version of the file(s), but you are not obligated to do so. If you do not
+ * wish to do so, delete this exception statement from your version. If you
+ * delete this exception statement from all source files in the program,
+ * then also delete it in the license file.
+ */
+
+#include "mongo/platform/basic.h"
+
+#include "mongo/db/matcher/array_positional_match.h"
+
+#include "mongo/base/string_data.h"
+
+namespace mongo {
+void ArrayPositionalMatch::reset() {
+    _arrayPosition = boost::none;
+}
+
+void ArrayPositionalMatch::requestArrayPosition() {
+    _arrayPositionRequested = true;
+}
+
+void ArrayPositionalMatch::setArrayPosition(StringData pos) {
+    if (_arrayPositionRequested) {
+        _arrayPosition = pos.toString();
+    }
+}
+}  // namespace mongo
diff --git a/src/mongo/db/matcher/array_positional_match.h b/src/mongo/db/matcher/array_positional_match.h
new file mode 100644
index 0000000000..895130c9dc
--- /dev/null
+++ b/src/mongo/db/matcher/array_positional_match.h
@@ -0,0 +1,84 @@
+/**
+ * Copyright (C) 2018 MongoDB Inc.
+ *
+ * This program is free software: you can redistribute it and/or  modify
+ * it under the terms of the GNU Affero General Public License, version 3,
+ * as published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Affero General Public License for more details.
+ *
+ * You should have received a copy of the GNU Affero General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * As a special exception, the copyright holders give permission to link the
+ * code of portions of this program with the OpenSSL library under certain
+ * conditions as described in each individual source file and distribute
+ * linked combinations including the program with the OpenSSL library. You
+ * must comply with the GNU Affero General Public License in all respects
+ * for all of the code used other than as permitted herein. If you modify
+ * file(s) with this exception, you may extend this exception to your
+ * version of the file(s), but you are not obligated to do so. If you do not
+ * wish to do so, delete this exception statement from your version. If you
+ * delete this exception statement from all source files in the program,
+ * then also delete it in the license file.
+ */
+
+#pragma once
+
+#include <boost/optional.hpp>
+#include <memory>
+#include <string>
+
+#include "mongo/base/string_data.h"
+
+namespace mongo {
+/**
+ * Stores the offset into an array for which an element satisfies a match predicate. Used for
+ * $elemMatch and $-positional projections.
+ */
+class ArrayPositionalMatch {
+public:
+    ArrayPositionalMatch() = default;
+
+    /**
+     * Returns true if a request has been made to store the array offset.
+     */
+    bool arrayPositionRequested() const {
+        return _arrayPositionRequested;
+    }
+
+    /**
+     * The array offset that satisfies the match predicate, if set.
+     */
+    boost::optional<std::string> arrayPosition() const {
+        return _arrayPosition;
+    }
+
+    /**
+     * Requests that the array match position be recorded.
+     */
+    void requestArrayPosition();
+
+    /**
+     * Sets the array match position to 'pos'. No effect if the array position has not been
+     * requested.
+     */
+    void setArrayPosition(StringData pos);
+
+    /**
+     * Resets any recorded array position. (If the position has been requested, though, it remains
+     * requested.)
+     */
+    void reset();
+
+private:
+    bool _arrayPositionRequested;
+
+    // If set, this contains the array index for which a match predicate was satisfied. The index is
+    // stored as a field name string (e.g. "1").
+    boost::optional<std::string> _arrayPosition;
+};
+}  // namespace mongo
diff --git a/src/mongo/db/matcher/expression.cpp b/src/mongo/db/matcher/expression.cpp
index 0c0efc660c..fb8f00192c 100644
--- a/src/mongo/db/matcher/expression.cpp
+++ b/src/mongo/db/matcher/expression.cpp
@@ -56,14 +56,18 @@ void MatchExpression::_debugAddSpace(StringBuilder& debug, int level) const {
         debug << "    ";
 }
 
-bool MatchExpression::matchesBSON(const BSONObj& doc, MatchDetails* details) const {
+bool MatchExpression::matchesBSON(const BSONObj& doc,
+                                  ArrayPositionalMatch* details,
+                                  std::deque<std::string>* explain) const {
     BSONMatchableDocument mydoc(doc);
-    return matches(&mydoc, details);
+    return matches(&mydoc, details, explain);
 }
 
-bool MatchExpression::matchesBSONElement(BSONElement elem, MatchDetails* details) const {
+bool MatchExpression::matchesBSONElement(BSONElement elem,
+                                         ArrayPositionalMatch* details,
+                                         std::deque<std::string>* explain) const {
     BSONElementViewMatchableDocument matchableDoc(elem);
-    return matches(&matchableDoc, details);
+    return matches(&matchableDoc, details, explain);
 }
 
 void MatchExpression::setCollator(const CollatorInterface* collator) {
diff --git a/src/mongo/db/matcher/expression.h b/src/mongo/db/matcher/expression.h
index bc0796dc1a..a1508c9792 100644
--- a/src/mongo/db/matcher/expression.h
+++ b/src/mongo/db/matcher/expression.h
@@ -35,7 +35,7 @@
 #include "mongo/base/status.h"
 #include "mongo/bson/bsonobj.h"
 #include "mongo/bson/bsonobjbuilder.h"
-#include "mongo/db/matcher/match_details.h"
+#include "mongo/db/matcher/array_positional_match.h"
 #include "mongo/db/matcher/matchable.h"
 #include "mongo/db/pipeline/dependencies.h"
 #include "mongo/stdx/functional.h"
@@ -214,12 +214,23 @@ public:
     virtual bool equivalent(const MatchExpression* other) const = 0;
 
     //
-    // Determine if a document satisfies the tree-predicate.
+    // Matching API.
     //
 
-    virtual bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const = 0;
+    /**
+     * Returns true if 'doc' satisfies the query predicate. If 'details' is set, it is filled with
+     * the array offset of the match if requested.
+     */
+    virtual bool matches(const MatchableDocument* doc,
+                         ArrayPositionalMatch* details = nullptr,
+                         std::deque<std::string>* explain = nullptr) const = 0;
 
-    virtual bool matchesBSON(const BSONObj& doc, MatchDetails* details = nullptr) const;
+    /**
+     * Returns true if the BSONObj satisfies the query predicate.
+     */
+    virtual bool matchesBSON(const BSONObj& doc,
+                             ArrayPositionalMatch* details = nullptr,
+                             std::deque<std::string>* = nullptr) const;
 
     /**
      * Determines if 'elem' would satisfy the predicate if wrapped with the top-level field name of
@@ -228,14 +239,17 @@ public:
      * obj["a"]["0"] because it performs the match as if the element at "a.0" were the BSONObj {i:
      * 5}.
      */
-    virtual bool matchesBSONElement(BSONElement elem, MatchDetails* details = nullptr) const;
+    virtual bool matchesBSONElement(BSONElement elem,
+                                    ArrayPositionalMatch* details = nullptr,
+                                    std::deque<std::string>* = nullptr) const;
 
     /**
      * Determines if the element satisfies the tree-predicate.
      * Not valid for all expressions (e.g. $where); in those cases, returns false.
      */
     virtual bool matchesSingleElement(const BSONElement& e,
-                                      MatchDetails* details = nullptr) const = 0;
+                                      ArrayPositionalMatch* details = nullptr,
+                                      std::deque<std::string>* = nullptr) const = 0;
 
     //
     // Tagging mechanism: Hang data off of the tree for retrieval later.
diff --git a/src/mongo/db/matcher/expression_always_boolean.h b/src/mongo/db/matcher/expression_always_boolean.h
index f7186d7028..6a87c84b7c 100644
--- a/src/mongo/db/matcher/expression_always_boolean.h
+++ b/src/mongo/db/matcher/expression_always_boolean.h
@@ -44,11 +44,15 @@ public:
      */
     virtual StringData name() const = 0;
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final {
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final {
         return _value;
     }
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         return _value;
     }
 
diff --git a/src/mongo/db/matcher/expression_array.cpp b/src/mongo/db/matcher/expression_array.cpp
index e4c9af9a02..4c01fc7560 100644
--- a/src/mongo/db/matcher/expression_array.cpp
+++ b/src/mongo/db/matcher/expression_array.cpp
@@ -36,12 +36,16 @@
 namespace mongo {
 
 bool ArrayMatchingMatchExpression::matchesSingleElement(const BSONElement& elt,
-                                                        MatchDetails* details) const {
+                                                        ArrayPositionalMatch* details,
+                                                        std::deque<std::string>* explain) const {
     if (elt.type() != BSONType::Array) {
+        if (explain) {
+            explain->push_front(str::stream() << elt.fieldNameStringData() << " is not an array");
+        }
         return false;
     }
 
-    return matchesArray(elt.embeddedObject(), details);
+    return matchesArray(elt.embeddedObject(), details, explain);
 }
 
 
@@ -72,19 +76,24 @@ ElemMatchObjectMatchExpression::ElemMatchObjectMatchExpression(StringData path,
     : ArrayMatchingMatchExpression(ELEM_MATCH_OBJECT, path), _sub(sub) {}
 
 bool ElemMatchObjectMatchExpression::matchesArray(const BSONObj& anArray,
-                                                  MatchDetails* details) const {
+                                                  ArrayPositionalMatch* details,
+                                                  std::deque<std::string>* explain) const {
     BSONObjIterator i(anArray);
     while (i.more()) {
         BSONElement inner = i.next();
         if (!inner.isABSONObj())
             continue;
-        if (_sub->matchesBSON(inner.Obj(), NULL)) {
-            if (details && details->needRecord()) {
-                details->setElemMatchKey(inner.fieldName());
+        if (_sub->matchesBSON(inner.Obj(), nullptr, explain)) {
+            if (details && details->arrayPositionRequested()) {
+                details->setArrayPosition(inner.fieldNameStringData());
             }
             return true;
         }
     }
+    if (explain) {
+        explain->push_front(str::stream() << "no elements of array '" << path()
+                                          << "' match the predicate");
+    }
     return false;
 }
 
@@ -138,14 +147,15 @@ void ElemMatchValueMatchExpression::add(MatchExpression* sub) {
 }
 
 bool ElemMatchValueMatchExpression::matchesArray(const BSONObj& anArray,
-                                                 MatchDetails* details) const {
+                                                 ArrayPositionalMatch* details,
+                                                 std::deque<std::string>* explain) const {
     BSONObjIterator i(anArray);
     while (i.more()) {
         BSONElement inner = i.next();
 
         if (_arrayElementMatchesAll(inner)) {
-            if (details && details->needRecord()) {
-                details->setElemMatchKey(inner.fieldName());
+            if (details && details->arrayPositionRequested()) {
+                details->setArrayPosition(inner.fieldNameStringData());
             }
             return true;
         }
@@ -207,7 +217,9 @@ MatchExpression::ExpressionOptimizerFunc ElemMatchValueMatchExpression::getOptim
 SizeMatchExpression::SizeMatchExpression(StringData path, int size)
     : ArrayMatchingMatchExpression(SIZE, path), _size(size) {}
 
-bool SizeMatchExpression::matchesArray(const BSONObj& anArray, MatchDetails* details) const {
+bool SizeMatchExpression::matchesArray(const BSONObj& anArray,
+                                       ArrayPositionalMatch* details,
+                                       std::deque<std::string>* explain) const {
     if (_size < 0)
         return false;
     return anArray.nFields() == _size;
diff --git a/src/mongo/db/matcher/expression_array.h b/src/mongo/db/matcher/expression_array.h
index 454f6a4a33..2505279a1a 100644
--- a/src/mongo/db/matcher/expression_array.h
+++ b/src/mongo/db/matcher/expression_array.h
@@ -58,9 +58,13 @@ public:
      *
      * 'anArray' must be the nested array at this expression's path.
      */
-    virtual bool matchesArray(const BSONObj& anArray, MatchDetails* details) const = 0;
+    virtual bool matchesArray(const BSONObj& anArray,
+                              ArrayPositionalMatch* details,
+                              std::deque<std::string>* explain) const = 0;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     bool equivalent(const MatchExpression* other) const override;
 
@@ -73,7 +77,9 @@ class ElemMatchObjectMatchExpression : public ArrayMatchingMatchExpression {
 public:
     ElemMatchObjectMatchExpression(StringData path, MatchExpression* sub);
 
-    bool matchesArray(const BSONObj& anArray, MatchDetails* details) const;
+    bool matchesArray(const BSONObj& anArray,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         std::unique_ptr<ElemMatchObjectMatchExpression> e =
@@ -126,7 +132,9 @@ public:
 
     void add(MatchExpression* sub);
 
-    bool matchesArray(const BSONObj& anArray, MatchDetails* details) const;
+    bool matchesArray(const BSONObj& anArray,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         std::unique_ptr<ElemMatchValueMatchExpression> e =
@@ -189,7 +197,9 @@ public:
         return nullptr;
     }
 
-    virtual bool matchesArray(const BSONObj& anArray, MatchDetails* details) const;
+    virtual bool matchesArray(const BSONObj& anArray,
+                              ArrayPositionalMatch* details,
+                              std::deque<std::string>* explain) const;
 
     virtual void debugString(StringBuilder& debug, int level) const;
 
diff --git a/src/mongo/db/matcher/expression_array_test.cpp b/src/mongo/db/matcher/expression_array_test.cpp
index 4d014818c2..892b5d6f93 100644
--- a/src/mongo/db/matcher/expression_array_test.cpp
+++ b/src/mongo/db/matcher/expression_array_test.cpp
@@ -120,22 +120,22 @@ TEST(ElemMatchObjectMatchExpression, ElemMatchKey) {
     BSONObj baseOperand = BSON("c" << 6);
     unique_ptr<ComparisonMatchExpression> eq(new EqualityMatchExpression("c", baseOperand["c"]));
     ElemMatchObjectMatchExpression op("a.b", eq.release());
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!op.matchesBSON(BSONObj(), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(!op.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY(BSON("c" << 7)))), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(op.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY(3 << BSON("c" << 6)))), &details));
-    ASSERT(details.hasElemMatchKey());
+    ASSERT(details.arrayPosition());
     // The entry within the $elemMatch array is reported.
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT_EQUALS("1", *details.arrayPosition());
     ASSERT(op.matchesBSON(
         BSON("a" << BSON_ARRAY(1 << 2 << BSON("b" << BSON_ARRAY(3 << 5 << BSON("c" << 6))))),
         &details));
-    ASSERT(details.hasElemMatchKey());
+    ASSERT(details.arrayPosition());
     // The entry within a parent of the $elemMatch array is reported.
-    ASSERT_EQUALS("2", details.elemMatchKey());
+    ASSERT_EQUALS("2", *details.arrayPosition());
 }
 
 TEST(ElemMatchObjectMatchExpression, Collation) {
@@ -228,21 +228,21 @@ TEST(ElemMatchValueMatchExpression, ElemMatchKey) {
     BSONObj baseOperand = BSON("$gt" << 6);
     unique_ptr<ComparisonMatchExpression> gt(new GTMatchExpression("", baseOperand["$gt"]));
     ElemMatchValueMatchExpression op("a.b", gt.release());
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!op.matchesBSON(BSONObj(), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(!op.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY(2))), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(op.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY(3 << 7))), &details));
-    ASSERT(details.hasElemMatchKey());
+    ASSERT(details.arrayPosition());
     // The entry within the $elemMatch array is reported.
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT_EQUALS("1", *details.arrayPosition());
     ASSERT(op.matchesBSON(BSON("a" << BSON_ARRAY(1 << 2 << BSON("b" << BSON_ARRAY(3 << 7)))),
                           &details));
-    ASSERT(details.hasElemMatchKey());
+    ASSERT(details.arrayPosition());
     // The entry within a parent of the $elemMatch array is reported.
-    ASSERT_EQUALS("2", details.elemMatchKey());
+    ASSERT_EQUALS("2", *details.arrayPosition());
 }
 
 /**
@@ -394,16 +394,16 @@ TEST(SizeMatchExpression, MatchesNestedArray) {
 
 TEST(SizeMatchExpression, ElemMatchKey) {
     SizeMatchExpression size("a.b", 3);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!size.matchesBSON(BSON("a" << 1), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(size.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY(1 << 2 << 3))), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(size.matchesBSON(BSON("a" << BSON_ARRAY(2 << BSON("b" << BSON_ARRAY(1 << 2 << 3)))),
                             &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(SizeMatchExpression, Equivalent) {
diff --git a/src/mongo/db/matcher/expression_expr.cpp b/src/mongo/db/matcher/expression_expr.cpp
index 18883040f9..a182c830bf 100644
--- a/src/mongo/db/matcher/expression_expr.cpp
+++ b/src/mongo/db/matcher/expression_expr.cpp
@@ -40,7 +40,9 @@ ExprMatchExpression::ExprMatchExpression(BSONElement elem,
     : ExprMatchExpression(Expression::parseOperand(expCtx, elem, expCtx->variablesParseState),
                           expCtx) {}
 
-bool ExprMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool ExprMatchExpression::matches(const MatchableDocument* doc,
+                                  ArrayPositionalMatch* details,
+                                  std::deque<std::string>* explain) const {
     if (_rewriteResult && _rewriteResult->matchExpression() &&
         !_rewriteResult->matchExpression()->matches(doc, details)) {
         return false;
